@ECHO OFF
IF NOT %CTERR%.==. GOTO END
REM #############################################################
REM                CodeTyphon Project 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################


if NOT EXIST %WINDIR%\SysWOW64 (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   INFO: Sorry, Your Operating System NOT support 64Bits 
ECHO          can NOT build Lazarus for x86_64-win64               
ECHO ???????????????????????????????????????????????????????????
ECHO.
GOTO END
)

ECHO.
ECHO =====================================================================
ECHO                  Build Lazarus for Win64 
ECHO =====================================================================
ECHO.

if NOT EXIST %FPCDIR%\units\x86_64-win64\rtl\classes.o (
  ECHO INFO: FreePascal Units for Win64 NOT EXIST !!!
  CALL x_FPC_Win64_Build
  IF NOT %CTERR%.==. GOTO ERROR
)

if NOT EXIST %LAZDIR%\Makefile.fpc (
  ECHO INFO: Lazarus Source NOT EXIST !!!
  CALL x_Lazarus_Exract_Source_from_ZipFile
  IF NOT %CTERR%.==. GOTO ERROR
)

ECHO.
ECHO -------------------------------------------------------
ECHO                  Prepare Lazarus Win64 
ECHO -------------------------------------------------------
ECHO.


IF NOT EXIST %LAZDIR%\bin64\ (
  mkdir %LAZDIR%\bin64
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: create %LAZDIR%\bin64 directory
)

IF EXIST %LAZDIR%\lazarus.exe (
  del /F /Q %LAZDIR%\lazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed lazarus.exe
)

IF EXIST %LAZDIR%\startlazarus.exe (
  del /F /Q %LAZDIR%\startlazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed startlazarus.exe
)

IF EXIST %LAZDIR%\lazbuild.exe (
  del /F /Q %LAZDIR%\lazbuild.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed lazbuild.exe
)

IF EXIST %LAZDIR%\xxlazarusWin32.txt (
  del /F /Q %LAZDIR%\xxlazarusWin32.txt
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed xxlazarusWin32.txt
)

IF EXIST ..\binSettings\win64\lazarus.exe (
  del /F /Q ..\binSettings\win64\lazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  del /F /Q ..\binSettings\win64\startlazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  del /F /Q ..\binSettings\win64\lazbuild.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed old building settings executables
)

IF EXIST ..\binSettings\win64user\lazarus.exe (
  del /F /Q ..\binSettings\win64user\lazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  del /F /Q ..\binSettings\win64user\startlazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  del /F /Q ..\binSettings\win64user\lazbuild.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed old user settings executables
)

del /F /Q ..\binSettings\win64user\lazarus\*.*
IF NOT ERRORLEVEL 0 GOTO ERROR
copy /Y ..\bin\xxlazarusWin64.txt %LAZDIR%\
IF NOT ERRORLEVEL 0 GOTO ERROR
CALL x_Lazarus_Settings_Restore
IF NOT %CTERR%.==. GOTO ERROR
ECHO.
ECHO -------------------------------------------------------
ECHO                  Clean Lazarus Win64 
ECHO -------------------------------------------------------
ECHO.
PUSHD %LAZDIR%\
%FPCDIR%\bin\x86_64-win64\make.exe clean
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  
ECHO.
ECHO -------------------------------------------------------
ECHO                  Compile Lazarus Win64 
ECHO -------------------------------------------------------
ECHO.

pushd %LAZDIR%\
%FPCDIR%\bin\x86_64-win64\make.exe bigide
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  

IF NOT EXIST %LAZTEMP%\ (
mkdir %LAZTEMP%
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: create %LAZTEMP% directory.
)

CALL x_Lazarus_User_Settings_Save
IF NOT %CTERR%.==. GOTO ERROR

IF EXIST %LAZDIR%\lazarus.exe (
ECHO.
ECHO ------- Copy Laz64 Executables to Settings -----------
copy /Y %LAZDIR%\lazarus.exe ..\binSettings\win64\
IF NOT ERRORLEVEL 0 GOTO ERROR
copy /Y %LAZDIR%\startlazarus.exe ..\binSettings\win64\
IF NOT ERRORLEVEL 0 GOTO ERROR
copy /Y %LAZDIR%\lazbuild.exe ..\binSettings\win64\
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO.
ECHO INFO: Lazarus64 IDE Build OK. Have fun.
) ELSE (
ECHO.
ECHO ??????????????????????????????????????????????????????
ECHO ERROR: Lazarus64 IDE NOT Build
ECHO ??????????????????????????????????????????????????????
)

GOTO END

:ERROR
echo ERROR !  %0
SET CTERR=1
:END
